## garmin 196 functions
var last_time = 0.0;
var last_bearing = -1;
var tab_chiffres_lettres = ["0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"];

var init_variables = func{
	##tests
	
	##init waypoint system
	props.globals.getNode("/instrumentation/garmin196/panel-wpt-bearing",1).setDoubleValue(0);
	props.globals.getNode("/instrumentation/garmin196/position-wpt-bearing",1).setDoubleValue(0);

	##init map system
	props.globals.getNode("/instrumentation/garmin196/map-range",1).setDoubleValue(0.125);
	
	##init dto system
	props.globals.getNode("/instrumentation/garmin196/dto_display/x_char",1).setIntValue(0);
	props.globals.getNode("/instrumentation/garmin196/dto_display/y_char",1).setIntValue(0);
	
	##init saveable variables
	props.globals.getNode("/instrumentation/garmin196/antenne-deg",1).setDoubleValue(30);
	props.globals.getNode("/instrumentation/garmin196/light",1).setDoubleValue(30);
	props.globals.getNode("/instrumentation/garmin196/max-speed",1).setDoubleValue(175);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/airport",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/vor",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/ndb",1).setBoolValue(1);
	props.globals.getNode("/instrumentation/garmin196/symbols/params/fix",1).setBoolValue(1);
	
	props.globals.getNode("/instrumentation/garmin196/version",1).setValue("JeeP v. 24/01/2012 0");
	
	##status du gps
	#0 eteint
	#1 startup page
	#1x map page
	#2x panel page
	#3x position page
	props.globals.getNode("/instrumentation/garmin196/status",1).setIntValue(0);
	
	##popup windows
	#0 = pas de popup
	#1 = affichage du reglage de la lumiere
	#10,11,12 = dto aviation
	#20 = dto recent
	#30 = dto user
	props.globals.getNode("/instrumentation/garmin196/popup_status",1).setIntValue(0);
	
	props.globals.getNode("/instrumentation/garmin196/serviceable",1).setBoolValue(0);
	props.globals.getNode("/instrumentation/garmin196/light",1).setDoubleValue(0);
	
	main_loop();
}
setlistener("/sim/signals/fdm-initialized",init_variables,0,0);

var load_parameters = func{
	fgcommand("loadxml", props.Node.new({ filename: getprop("/sim/fg-home")~"/aircraft-data/garmin196.xml", targetnode: "/instrumentation/garmin196/save" }));
	
	if(getprop("/instrumentation/garmin196/save/antenne-deg")!=nil){
		setprop("/instrumentation/garmin196/antenne-deg",getprop("/instrumentation/garmin196/save/antenne-deg"));
	}
	if(getprop("/instrumentation/garmin196/save/light")!=nil){
		setprop("/instrumentation/garmin196/light",getprop("/instrumentation/garmin196/save/light"));
	}
	if(getprop("/instrumentation/garmin196/save/max-speed")!=nil){
		setprop("/instrumentation/garmin196/max-speed",getprop("/instrumentation/garmin196/save/max-speed"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/airport")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/airport",getprop("/instrumentation/garmin196/save/symbols/params/airport"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/vor")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/vor",getprop("/instrumentation/garmin196/save/symbols/params/vor"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/ndb")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/ndb",getprop("/instrumentation/garmin196/save/symbols/params/ndb"));
	}
	if(getprop("/instrumentation/garmin196/save/symbols/params/fix")!=nil){
		setprop("/instrumentation/garmin196/symbols/params/fix",getprop("/instrumentation/garmin196/save/symbols/params/fix"));
	}
	
	for(var i=0;i<5;i=i+1){
		if(getprop("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/id")!=nil){
			props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id",1).setValue(getprop("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/id"));
			props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/type",1).setValue(getprop("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/type"));
		}
	}
	
}
setlistener("/sim/signals/fdm-initialized",load_parameters);

var save_parameters = func{
		##preparation
		if(getprop("/instrumentation/garmin196/antenne-deg")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/antenne-deg",1).setDoubleValue(getprop("/instrumentation/garmin196/antenne-deg"));
		}
		if(getprop("/instrumentation/garmin196/light")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/light",1).setDoubleValue(getprop("/instrumentation/garmin196/light"));
		}
		if(getprop("/instrumentation/garmin196/max-speed")!=nil){
			props.globals.getNode("/instrumentation/garmin196/save/max-speed",1).setDoubleValue(getprop("/instrumentation/garmin196/max-speed"));
		}
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/airport",1).setDoubleValue(getprop("/instrumentation/garmin196/symbols/params/airport"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/vor",1).setDoubleValue(getprop("/instrumentation/garmin196/symbols/params/vor"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/ndb",1).setDoubleValue(getprop("/instrumentation/garmin196/symbols/params/ndb"));
		props.globals.getNode("/instrumentation/garmin196/save/symbols/params/fix",1).setDoubleValue(getprop("/instrumentation/garmin196/symbols/params/fix"));
		
		for(var i=0;i<5;i=i+1){
			if(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id")!=nil){
				props.globals.getNode("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/id",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id"));
				props.globals.getNode("/instrumentation/garmin196/save/waypoints/recent/wpt["~i~"]/type",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/type"));
			}
		}
		fgcommand("savexml", props.Node.new({ filename: getprop("/sim/fg-home")~"/aircraft-data/garmin196.xml", sourcenode: "/instrumentation/garmin196/save" }));
}

var main_loop = func{
	var time = getprop("/sim/time/elapsed-sec");
    var dt = time - last_time;
    last_time = time;
	
	calcul_turn_rate(dt);
	change_speed_display();
	change_position_wpt_bug();
	
	settimer(main_loop, 0.3);
}

var nyi = func (x) { gui.popupTip(x ~ ": not yet implemented", 3); }

var power = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(x==0){
		if(serviceable==1){
			setprop("/instrumentation/garmin196/serviceable",0);
			setprop("/instrumentation/garmin196/status",0);
			setprop("/instrumentation/garmin196/popup_status",0);
		}else{
			setprop("/instrumentation/garmin196/serviceable",1);
			setprop("/instrumentation/garmin196/status",1);
		}
	}
	
	if(x==1 and serviceable==1){
		setprop("/instrumentation/garmin196/popup_status",1)
	}

}

var in = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				var range = getprop("/instrumentation/garmin196/map-range");
				range = range / 2;
				if(range<0.125){
					range = 0.125;
				}
				setprop("/instrumentation/garmin196/map-range",range);
				return;
			}
		}
	}
}

var out = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				var range = getprop("/instrumentation/garmin196/map-range");
				range = range * 2;
				if(range>8){
					range = 8;
				}
				setprop("/instrumentation/garmin196/map-range",range);
				return;
			}
		}
	}
}

var page = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/status",20);
				return;
			}
			
			if(status==20){
				setprop("/instrumentation/garmin196/status",30);
				return;
			}
			
			if(status==30){
				setprop("/instrumentation/garmin196/status",10);
				update_map();
				return;
			}
		}
	}
}

var quit = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				setprop("/instrumentation/garmin196/popup_status",0);
				save_parameters();
				return;
			}
			if(popup_status>=10 and popup_status<=39){
				setprop("/instrumentation/garmin196/popup_status",0);
				return;
			}
			
			##traitement des pages
			var status = getprop("/instrumentation/garmin196/status");
			if(status==10){
				setprop("/instrumentation/garmin196/status",30);
				return;
			}
			
			if(status==20){
				setprop("/instrumentation/garmin196/status",10);
				update_map();
				return;
			}
			
			if(status==30){
				setprop("/instrumentation/garmin196/status",20);
				return;
			}
		}
	}
}

var enter = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				setprop("/instrumentation/garmin196/popup_status",0);
				save_parameters();
				return;
			}
			
			if(popup_status==10){
				setprop("/instrumentation/garmin196/popup_status",11);
				display_dto_search();
				return;
			}
			
			if(popup_status==11){
				if(getprop("/instrumentation/garmin196/dto_display/max_ligne_selected")>0){
					setprop("/instrumentation/garmin196/popup_status",12);
					return;
				}
			}
			
			if(popup_status==12){
				setprop("/instrumentation/garmin196/popup_status",0);
				var id = getprop("/instrumentation/garmin196/dto_display/ligne["~getprop("/instrumentation/garmin196/dto_display/no_ligne_selected")~"]/id");
				var type = getprop("/instrumentation/garmin196/dto_display/ligne["~getprop("/instrumentation/garmin196/dto_display/no_ligne_selected")~"]/type");
				affectation_waypoint(id);
				##rolling recents waypoints
				for(var i=4;i>0;i=i-1){
					if(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~(i-1)~"]/id")){
						props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/id",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~(i-1)~"]/id"));
						props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt["~i~"]/type",1).setValue(getprop("/instrumentation/garmin196/waypoints/recent/wpt["~(i-1)~"]/type"));
					}
				}
				props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt[0]/id",1).setValue(id);
				props.globals.getNode("/instrumentation/garmin196/waypoints/recent/wpt[0]/type",1).setValue(type);
				save_parameters();
				return;
			}
			
			if(popup_status==20){
				setprop("/instrumentation/garmin196/popup_status",0);
				var id = getprop("/instrumentation/garmin196/dto_display/ligne["~getprop("/instrumentation/garmin196/dto_display/no_ligne_selected")~"]/id");
				var type = getprop("/instrumentation/garmin196/dto_display/ligne["~getprop("/instrumentation/garmin196/dto_display/no_ligne_selected")~"]/type");
				affectation_waypoint(id);
				return;
			}
			
			##validation de la startup page
			var status = getprop("/instrumentation/garmin196/status");
			if(status==1){
				#setprop("/instrumentation/garmin196/status",10);
				
				update_map();
				return;
			}
		}
	}
}

var menu = func (x){
	nyi("menu");
}

var nrst = func (x){
	nyi("nrst");
}

var dto = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	var status = getprop("/instrumentation/garmin196/status");
	if(serviceable==1 and status>1){
		if(x==0){
			setprop("/instrumentation/garmin196/popup_status",10);
			setprop("/instrumentation/garmin196/dto_display/ligne_select","Press Enter to search");
			init_dto_display();
			setprop("/instrumentation/garmin196/dto_display/x_char",0);
			setprop("/instrumentation/garmin196/dto_display/y_char",0);
		}
	}
}

var rockerup = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				var light_level = getprop("/instrumentation/garmin196/light");
				light_level = light_level + 0.1;
				if(light_level>1){
					light_level = 1;
				}
				setprop("/instrumentation/garmin196/light",light_level);
				return;
			}
			
			if(popup_status==11){
				var y_char = getprop("/instrumentation/garmin196/dto_display/y_char");
				y_char = y_char + 1;
				if(y_char>35){
					y_char = 0;
				}
				setprop("/instrumentation/garmin196/dto_display/y_char",y_char);
				display_dto_search();
				return;
			}
			
			if(popup_status==12){
				var no_ligne = getprop("/instrumentation/garmin196/dto_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				no_ligne = no_ligne - 1;
				if(no_ligne<0){
					no_ligne = 0;
				}
				setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",no_ligne);
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/dto_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
			
			if(popup_status==20){
				var no_ligne = getprop("/instrumentation/garmin196/dto_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				no_ligne = no_ligne - 1;
				if(no_ligne<0){
					no_ligne = 0;
				}
				setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",no_ligne);
				setprop("/instrumentation/garmin196/dto_display/ligne_select",getprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/texte"));
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/dto_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
		}
	}
}

var rockerdown = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==1){
				var light_level = getprop("/instrumentation/garmin196/light");
				light_level = light_level - 0.1;
				if(light_level<0){
					light_level = 0;
				}
				setprop("/instrumentation/garmin196/light",light_level);
				return;
			}
			
			if(popup_status==11){
				var y_char = getprop("/instrumentation/garmin196/dto_display/y_char");
				y_char = y_char - 1;
				if(y_char<0){
					y_char = 35;
				}
				setprop("/instrumentation/garmin196/dto_display/y_char",y_char);
				display_dto_search();
				return;
			}
			
			if(popup_status==12){
				var no_ligne = getprop("/instrumentation/garmin196/dto_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				var max_ligne = getprop("/instrumentation/garmin196/dto_display/max_ligne_selected");
				no_ligne = no_ligne + 1;
				if(no_ligne>max_ligne){
					no_ligne = max_ligne;
				}
				setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",no_ligne);
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/dto_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
			
			if(popup_status==20){
				var no_ligne = getprop("/instrumentation/garmin196/dto_display/no_ligne_selected");
				var old_no_ligne = no_ligne;
				var max_ligne = getprop("/instrumentation/garmin196/dto_display/max_ligne_selected");
				no_ligne = no_ligne + 1;
				if(no_ligne>max_ligne){
					no_ligne = max_ligne;
				}
				setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",no_ligne);
				setprop("/instrumentation/garmin196/dto_display/ligne_select",getprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/texte"));
				if(old_no_ligne!=no_ligne){
					setprop("/instrumentation/garmin196/dto_display/ligne["~no_ligne~"]/selected",1);
					setprop("/instrumentation/garmin196/dto_display/ligne["~old_no_ligne~"]/selected",0);
				}
				return;
			}
							
		}
	}
}

var rockerleft = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==10){
				setprop("/instrumentation/garmin196/popup_status",30);
				return;
			}
			if(popup_status==11){
				var x_char = getprop("/instrumentation/garmin196/dto_display/x_char");
				if(x_char>0){
					setprop("/instrumentation/garmin196/dto_display/x_char",x_char-1);
					setprop("/instrumentation/garmin196/dto_display/y_char",searchLastChar(getprop("/instrumentation/garmin196/dto_display/ligne_select"),getprop("/instrumentation/garmin196/dto_display/x_char")));
					display_dto_search();
				}
				return;
			}
			if(popup_status==20){
				setprop("/instrumentation/garmin196/popup_status",10);
				setprop("/instrumentation/garmin196/dto_display/x_char",0);
				setprop("/instrumentation/garmin196/dto_display/y_char",0);
				setprop("/instrumentation/garmin196/dto_display/ligne_select","Press Enter to search");
				init_dto_display();
				return;
			}
			if(popup_status==30){
				setprop("/instrumentation/garmin196/popup_status",20);
				setprop("/instrumentation/garmin196/dto_display/ligne_select","");
				init_dto_display();
				display_dto_recent();
				return;
			}
		}
	}
}

var rockerright = func (x){
	var serviceable = getprop("/instrumentation/garmin196/serviceable");
	if(serviceable==1){
		if(x==0){
			#traitement des popup
			var popup_status = getprop("/instrumentation/garmin196/popup_status");
			if(popup_status==10){
				setprop("/instrumentation/garmin196/popup_status",20);
				setprop("/instrumentation/garmin196/dto_display/ligne_select","");
				init_dto_display();
				display_dto_recent();
				return;
			}
			if(popup_status==11){
				var x_char = getprop("/instrumentation/garmin196/dto_display/x_char");
				if(x_char<20){
					setprop("/instrumentation/garmin196/dto_display/x_char",x_char+1);
					display_dto_search();
				}
				return;
			}
			if(popup_status==20){
				setprop("/instrumentation/garmin196/popup_status",30);
				return;
			}
			if(popup_status==30){
				setprop("/instrumentation/garmin196/popup_status",10);
				setprop("/instrumentation/garmin196/dto_display/ligne_select","Press Enter to search");
				init_dto_display();
				setprop("/instrumentation/garmin196/dto_display/x_char",0);
				setprop("/instrumentation/garmin196/dto_display/y_char",0);
				return;
			}
		}
	}
}

##recalc speed to display
var change_speed_display = func{
	var max_speed = getprop("/instrumentation/garmin196/max-speed");
	var speed = getprop("/instrumentation/gps/indicated-ground-speed-kt");
	setprop("/instrumentation/garmin196/speed-display",315*speed/max_speed);
}

##calcul du turn rate
var calcul_turn_rate = func(dt){
	if(last_bearing==-1){
		last_bearing = getprop("/instrumentation/gps/magnetic-bug-error-deg");
	}
	bearing = getprop("/instrumentation/gps/magnetic-bug-error-deg");
	
	var turn_rate = abs(bearing - last_bearing);
	if(turn_rate>180){
		turn_rate = 360 - turn_rate;
 	}
	var sgn = 1;
	if(bearing - last_bearing<0){
		sgn = -1;
	}
	turn_rate = turn_rate/dt;
	if(turn_rate<10){##pour enlever les valeurs aberentes
		props.globals.getNode("/instrumentation/garmin196/turn-rate",1).setDoubleValue(sgn*turn_rate);
	}
	last_bearing = bearing;
}

var change_wpt_id = func{
	if(getprop("/instrument/gps/mode")!=nil and getprop("/autopilot/route-manager/wp[0]/id")!=""){
		props.global.getNode("/instrumentation/garmin196/panel-wpt-id").alias("/autopilot/route-manager/wp[0]/id");
	}else{
		setprop("/instrumentation/garmin196/panel-wpt-id",getprop("/instrumentation/garmin196/panel-wpt-dto-id"));
	}
}
setlistener("/instrumentation/gps/mode",change_wpt_id);

var change_position_wpt_bug = func{
	var wpt_bearing = getprop("/instrumentation/gps/wp/wp[1]/bearing-mag-deg");
	var aircraft_bearing = getprop("/instrumentation/gps/indicated-track-magnetic-deg");
	
	var diff = wpt_bearing - aircraft_bearing;
	setprop("/instrumentation/garmin196/position-wpt-bearing",diff);
	setprop("/instrumentation/garmin196/panel-wpt-bearing",diff);
}

var update_map = func{
	var max_plots = 25;
	var offset_mul = 0.034;
	var symbol_map_range = getprop("/instrumentation/garmin196/map-range") * 8;
	var plots = [];
	var type_symbol = [ "airport" , "vor" , "ndb" , "fix" ];
	
	for(var i=0;i<size(type_symbol);i=i+1){
		if(getprop("/instrumentation/garmin196/symbols/params/"~type_symbol[i])==1){
			props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(max_plots + 1);
			props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
			props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
			setprop("/instrumentation/gps/scratch/type", type_symbol[i]);
			setprop("/instrumentation/gps/command", "nearest");
			
			while (getprop('/instrumentation/gps/scratch/has-next')) {
				var id = getprop('/instrumentation/gps/scratch/ident');
				var range = getprop('/instrumentation/gps/scratch/distance-nm') / symbol_map_range; 
				var bearing = 360 - getprop("/instrumentation/gps/indicated-track-magnetic-deg") + getprop('/instrumentation/gps/scratch/mag-bearing-deg');
				#var bearing = 360 - getprop("/orientation/heading-deg") + getprop('/instrumentation/gps/scratch/mag-bearing-deg');
				if(bearing<0){
					bearing = bearing + 360;
				}
				
				if(bearing>360){
					bearing = bearing - 360;
				}
				
				if(i==1){##vor
					id = id ~ " " ~ sprintf("%2.2f",getprop('/instrumentation/gps/scratch/frequency-mhz'));
				}
				
				if(i==2){##ndb
					id = id ~ " " ~ sprintf("%2.1f",getprop('/instrumentation/gps/scratch/frequency-khz'));
				}
				
				var plot = { id: id,bearing: bearing,type: i,range: range};
				if(range<=1){
					append(plots,plot);
				}else{
					break;
				}
				setprop("/instrumentation/gps/command", "next");
			}
		}
	}

	var plots_sorted = sort (plots, func (a,b) a.range - b.range);
	var nb_plots = max_plots;
	if(nb_plots>size(plots_sorted)){
		nb_plots = size(plots_sorted);
	}
	for(var i=0;i<nb_plots;i=i+1){
		props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/id",1).setValue(plots_sorted[i].id);
		props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/type",1).setValue(plots_sorted[i].type);
		
		##calcul des coordonnees
		var x_wp = math.cos(plots_sorted[i].bearing*math.pi/180) * plots_sorted[i].range * offset_mul;
		var y_wp = math.sin(plots_sorted[i].bearing*math.pi/180) * plots_sorted[i].range * offset_mul;
		props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/x",1).setDoubleValue(x_wp);
		props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/y",1).setDoubleValue(y_wp);
		props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/brg_offset",1).setDoubleValue(plots_sorted[i].bearing);
		props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/norm_dist",1).setDoubleValue(plots_sorted[i].range);
		#
		if(x_wp<0.026 and x_wp>-0.026 and y_wp<0.0323 and y_wp>-0.0323){##si on est dans l'ecran, on affiche
			props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/visible",1).setBoolValue(1);
		}else{
			props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/visible",1).setBoolValue(0);
		}
	}

	for(var i=nb_plots;i<max_plots;i=i+1){
		props.globals.getNode("/instrumentation/garmin196/symbols/symbol["~i~"]/visible",1).setIntValue(0);
	}
	
	if(getprop("/instrumentation/garmin196/serviceable")==1 and getprop("/instrumentation/garmin196/status")==10){
		settimer(update_map,1);
	}
}

var display_dto_recent = func{
	var waypoints = props.globals.getNode("/instrumentation/garmin196/waypoints/recent/",1);
	var i = 0;
	foreach (var e; waypoints.getChildren("wpt")) {
		var id = e.getChild("id").getValue();
		var type = e.getChild("type").getValue();
		var ligne = sprintf("%s %s",id,type);
		var ligne_spaces = "                              ";
		ligne_spaces = substr(ligne_spaces,0,16-size(ligne));
		
		props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(1);
		props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
		props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
		setprop("/instrumentation/gps/scratch/type", type);
		setprop("/instrumentation/gps/scratch/query", id);
		setprop("/instrumentation/gps/command", "search");
		
		var range = getprop("/instrumentation/gps/scratch/distance-nm");
		var	bearing = getprop("/instrumentation/gps/scratch/mag-bearing-deg");

        ligne = ligne ~ ligne_spaces ~ sprintf(" %03.f   %3.1fnm",bearing,range);
		
		if(i==0){
			setprop("/instrumentation/garmin196/dto_display/ligne_select",ligne);
			props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(1);
		}else{
			props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(0);
		}
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/texte",ligne);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/id",id);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/type",type);
		i=i+1;
	}
	for(var j=i;j<5;j=j+1){
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/texte","");
		props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~j~"]/selected",1).setBoolValue(0);
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/id","");
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/type","");
	}
	setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",0);
	setprop("/instrumentation/garmin196/dto_display/max_ligne_selected",i-1);
	if(i==0){
		setprop("/instrumentation/garmin196/dto_display/ligne_select","");
	}
}

var affectation_waypoint = func(id){
	setprop("/autopilot/route-manager/input","@CLEAR");
	setprop("/autopilot/route-manager/input","@insert0:"~id);
	setprop("/autopilot/route-manager/input","@JUMP0");
	setprop("/autopilot/route-manager/input","@ACTIVATE");
}

var display_dto_search = func{
	var ligne_selected = getprop("/instrumentation/garmin196/dto_display/ligne_select");
	var x_char = props.globals.getNode("/instrumentation/garmin196/dto_display/x_char").getValue();
	ligne_selected = substr(ligne_selected,0,x_char);
	ligne_selected = ligne_selected ~ tab_chiffres_lettres[getprop("/instrumentation/garmin196/dto_display/y_char")];
	setprop("/instrumentation/garmin196/dto_display/ligne_select",ligne_selected);

	##recherche gps
	props.globals.getNode("/instrumentation/gps/scratch/max-results", 1).setIntValue(5);
	props.globals.getNode("/instrumentation/gps/scratch/longitude-deg", 1).setDoubleValue(-9999);
	props.globals.getNode("/instrumentation/gps/scratch/latitude-deg", 1).setDoubleValue(-9999);
	props.globals.getNode("/instrumentation/gps/scratch/exact", 1).setBoolValue(0);
	props.globals.getNode("/instrumentation/gps/scratch/query",1).setValue(ligne_selected);
	
	setprop("/instrumentation/gps/command", "search");
	var i=0;
	var flag_continue = getprop("/instrumentation/gps/scratch/valid");
	while (flag_continue and i<5) {
		var id = getprop('/instrumentation/gps/scratch/ident');
		var range = getprop('/instrumentation/gps/scratch/distance-nm');
		var bearing = getprop('/instrumentation/gps/scratch/mag-bearing-deg');
		var type = getprop('/instrumentation/gps/scratch/type');
		
		var ligne = sprintf("%s %s",id,type);
		var ligne_spaces = "                              ";
		ligne_spaces = substr(ligne_spaces,0,16-size(ligne));
		
		ligne = ligne ~ ligne_spaces ~ sprintf(" %03.f   %3.1fnm",bearing,range);
		
		if(i==0){
			props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(1);
		}else{
			props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(0);
		}
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/texte",ligne);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/id",id);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/type",type);
		
		i=i+1;
		setprop("/instrumentation/gps/command", "next");
		flag_continue = getprop("/instrumentation/gps/scratch/has-next");
	}
	
	for(var j=i;j<5;j=j+1){
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/texte","");
		props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~j~"]/selected",1).setBoolValue(0);
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/id","");
		setprop("/instrumentation/garmin196/dto_display/ligne["~j~"]/type","");
	}
	setprop("/instrumentation/garmin196/dto_display/no_ligne_selected",0);
	setprop("/instrumentation/garmin196/dto_display/max_ligne_selected",i-1);
}

var searchLastChar = func(chaine, char){
	var result = -1;
	var char_a_tester = substr(chaine,char,1);
	for(var i=0;i<size(tab_chiffres_lettres);i=i+1){
		if(tab_chiffres_lettres[i]==char_a_tester){
			result = i;
			break;
		}
	}
	return result;
}

var init_dto_display = func{
	for(var i=0;i<5;i=i+1){
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/texte","");
		props.globals.getNode("/instrumentation/garmin196/dto_display/ligne["~i~"]/selected",1).setBoolValue(0);
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/id","");
		setprop("/instrumentation/garmin196/dto_display/ligne["~i~"]/type","");
	}
}










